/**
 * Copyright (C) 2013, 2014 Johannes Taelman
 *
 * This file is part of Axoloti.
 *
 * Axoloti is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * Axoloti is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Axoloti. If not, see <http://www.gnu.org/licenses/>.
 */
package axoloti.dialogs;

import axoloti.object.AxoObject;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import javax.swing.ImageIcon;
import javax.swing.JFrame;

/**
 *
 * @author Johannes Taelman
 */
public class AxoObjectEditor extends JFrame {

    AxoObject obj;

    public AxoObjectEditor(AxoObject obj) {
        initComponents();
        setIconImage(new ImageIcon(getClass().getResource("/resources/axoloti_icon.png")).getImage());
        setTitle(obj.id);
        this.obj = obj;
        jTextAreaLocalData.setText(obj.sLocalData);
        jTextAreaInitCode.setText(obj.sInitCode);
        jTextAreaKRateCode.setText(obj.sKRateCode);
        jTextAreaSRateCode.setText(obj.sSRateCode);
        jTextAreaDisposeCode.setText(obj.sDisposeCode);
        jTextAreaMidiCode.setText(obj.sMidiCode);
        FocusListener fl = new FocusListener() {
            @Override
            public void focusGained(FocusEvent e) {
            }

            @Override
            public void focusLost(FocusEvent e) {
                AxoObjectEditor.this.obj.sLocalData = jTextAreaLocalData.getText();
                AxoObjectEditor.this.obj.sInitCode = jTextAreaInitCode.getText();
                AxoObjectEditor.this.obj.sKRateCode = jTextAreaKRateCode.getText();
                AxoObjectEditor.this.obj.sSRateCode = jTextAreaSRateCode.getText();
                AxoObjectEditor.this.obj.sDisposeCode = jTextAreaDisposeCode.getText();
            }
        };

        jTextAreaLocalData.addFocusListener(fl);
        jTextAreaInitCode.addFocusListener(fl);
        jTextAreaKRateCode.addFocusListener(fl);
        jTextAreaSRateCode.addFocusListener(fl);
        jTextAreaDisposeCode.addFocusListener(fl);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jInternalFrame1 = new javax.swing.JInternalFrame();
        jLabel1 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel2 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanelInlets = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jListInlets = new javax.swing.JList();
        jPanelOutlets = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jListOutlets = new javax.swing.JList();
        jPanelAttributes = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jListAttributes = new javax.swing.JList();
        jPanelParameters = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        jListParameters = new javax.swing.JList();
        jPanelLocalData = new javax.swing.JPanel();
        jScrollPane9 = new javax.swing.JScrollPane();
        jTextAreaLocalData = new javax.swing.JTextArea();
        jPanelInitCode = new javax.swing.JPanel();
        jScrollPane6 = new javax.swing.JScrollPane();
        jTextAreaInitCode = new javax.swing.JTextArea();
        jPanelKRateCode = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTextAreaKRateCode = new javax.swing.JTextArea();
        jPanelSRateCode = new javax.swing.JPanel();
        jScrollPane7 = new javax.swing.JScrollPane();
        jTextAreaSRateCode = new javax.swing.JTextArea();
        jPanelDisposeCode = new javax.swing.JPanel();
        jScrollPane8 = new javax.swing.JScrollPane();
        jTextAreaDisposeCode = new javax.swing.JTextArea();
        jPanelMidiCode = new javax.swing.JPanel();
        jScrollPane10 = new javax.swing.JScrollPane();
        jTextAreaMidiCode = new javax.swing.JTextArea();
        jLabel2 = new javax.swing.JLabel();

        jInternalFrame1.setVisible(true);

        javax.swing.GroupLayout jInternalFrame1Layout = new javax.swing.GroupLayout(jInternalFrame1.getContentPane());
        jInternalFrame1.getContentPane().setLayout(jInternalFrame1Layout);
        jInternalFrame1Layout.setHorizontalGroup(
            jInternalFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jInternalFrame1Layout.setVerticalGroup(
            jInternalFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.PAGE_AXIS));

        jLabel1.setText("This object editor is uncomplete. The tabs for inlets, outlets, parameters, attributes are not working. ");
        jLabel1.setVerifyInputWhenFocusTarget(false);
        getContentPane().add(jLabel1);

        jLabel3.setText("Only the code-editors work. Changes are applied only by enabling live on a patch. Changes propagate to all instances wihtout reloading.");
        getContentPane().add(jLabel3);
        getContentPane().add(jLabel4);

        jSplitPane1.setDividerLocation(600);
        jSplitPane1.setResizeWeight(0.9);

        jPanel2.setPreferredSize(new java.awt.Dimension(140, 466));

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 535, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 438, Short.MAX_VALUE)
        );

        jSplitPane1.setRightComponent(jPanel2);

        jPanel1.setPreferredSize(new java.awt.Dimension(640, 100));
        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.PAGE_AXIS));

        jTabbedPane1.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        jTabbedPane1.setTabPlacement(javax.swing.JTabbedPane.LEFT);
        jTabbedPane1.setPreferredSize(new java.awt.Dimension(640, 100));

        jListInlets.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jListInlets.setEnabled(false);
        jScrollPane1.setViewportView(jListInlets);

        javax.swing.GroupLayout jPanelInletsLayout = new javax.swing.GroupLayout(jPanelInlets);
        jPanelInlets.setLayout(jPanelInletsLayout);
        jPanelInletsLayout.setHorizontalGroup(
            jPanelInletsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelInletsLayout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE)
                .addGap(0, 0, 0))
        );
        jPanelInletsLayout.setVerticalGroup(
            jPanelInletsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 433, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("Inlets", jPanelInlets);

        jListOutlets.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane2.setViewportView(jListOutlets);

        javax.swing.GroupLayout jPanelOutletsLayout = new javax.swing.GroupLayout(jPanelOutlets);
        jPanelOutlets.setLayout(jPanelOutletsLayout);
        jPanelOutletsLayout.setHorizontalGroup(
            jPanelOutletsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelOutletsLayout.createSequentialGroup()
                .addGap(0, 0, 0)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE))
        );
        jPanelOutletsLayout.setVerticalGroup(
            jPanelOutletsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 433, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("Outlets", jPanelOutlets);

        jListAttributes.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane3.setViewportView(jListAttributes);

        javax.swing.GroupLayout jPanelAttributesLayout = new javax.swing.GroupLayout(jPanelAttributes);
        jPanelAttributes.setLayout(jPanelAttributesLayout);
        jPanelAttributesLayout.setHorizontalGroup(
            jPanelAttributesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelAttributesLayout.createSequentialGroup()
                .addGap(0, 0, 0)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE))
        );
        jPanelAttributesLayout.setVerticalGroup(
            jPanelAttributesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 433, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("Attributes", jPanelAttributes);

        jListParameters.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane4.setViewportView(jListParameters);

        javax.swing.GroupLayout jPanelParametersLayout = new javax.swing.GroupLayout(jPanelParameters);
        jPanelParameters.setLayout(jPanelParametersLayout);
        jPanelParametersLayout.setHorizontalGroup(
            jPanelParametersLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelParametersLayout.createSequentialGroup()
                .addGap(0, 0, 0)
                .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE))
        );
        jPanelParametersLayout.setVerticalGroup(
            jPanelParametersLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 433, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("Parameters", jPanelParameters);

        jTextAreaLocalData.setColumns(20);
        jTextAreaLocalData.setRows(5);
        jScrollPane9.setViewportView(jTextAreaLocalData);

        javax.swing.GroupLayout jPanelLocalDataLayout = new javax.swing.GroupLayout(jPanelLocalData);
        jPanelLocalData.setLayout(jPanelLocalDataLayout);
        jPanelLocalDataLayout.setHorizontalGroup(
            jPanelLocalDataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane9, javax.swing.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE)
        );
        jPanelLocalDataLayout.setVerticalGroup(
            jPanelLocalDataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane9, javax.swing.GroupLayout.DEFAULT_SIZE, 433, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("Local Data", jPanelLocalData);

        jTextAreaInitCode.setColumns(20);
        jTextAreaInitCode.setRows(5);
        jScrollPane6.setViewportView(jTextAreaInitCode);

        javax.swing.GroupLayout jPanelInitCodeLayout = new javax.swing.GroupLayout(jPanelInitCode);
        jPanelInitCode.setLayout(jPanelInitCodeLayout);
        jPanelInitCodeLayout.setHorizontalGroup(
            jPanelInitCodeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelInitCodeLayout.createSequentialGroup()
                .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE)
                .addGap(0, 0, 0))
        );
        jPanelInitCodeLayout.setVerticalGroup(
            jPanelInitCodeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 433, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("Init Code", jPanelInitCode);

        jTextAreaKRateCode.setColumns(20);
        jTextAreaKRateCode.setRows(5);
        jScrollPane5.setViewportView(jTextAreaKRateCode);

        javax.swing.GroupLayout jPanelKRateCodeLayout = new javax.swing.GroupLayout(jPanelKRateCode);
        jPanelKRateCode.setLayout(jPanelKRateCodeLayout);
        jPanelKRateCodeLayout.setHorizontalGroup(
            jPanelKRateCodeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelKRateCodeLayout.createSequentialGroup()
                .addGap(0, 0, 0)
                .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE))
        );
        jPanelKRateCodeLayout.setVerticalGroup(
            jPanelKRateCodeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 433, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("K-rate Code", jPanelKRateCode);

        jTextAreaSRateCode.setColumns(20);
        jTextAreaSRateCode.setRows(5);
        jScrollPane7.setViewportView(jTextAreaSRateCode);

        javax.swing.GroupLayout jPanelSRateCodeLayout = new javax.swing.GroupLayout(jPanelSRateCode);
        jPanelSRateCode.setLayout(jPanelSRateCodeLayout);
        jPanelSRateCodeLayout.setHorizontalGroup(
            jPanelSRateCodeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelSRateCodeLayout.createSequentialGroup()
                .addComponent(jScrollPane7, javax.swing.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE)
                .addGap(0, 0, 0))
        );
        jPanelSRateCodeLayout.setVerticalGroup(
            jPanelSRateCodeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane7, javax.swing.GroupLayout.DEFAULT_SIZE, 433, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("S-rate Code", jPanelSRateCode);

        jTextAreaDisposeCode.setColumns(20);
        jTextAreaDisposeCode.setRows(5);
        jScrollPane8.setViewportView(jTextAreaDisposeCode);

        javax.swing.GroupLayout jPanelDisposeCodeLayout = new javax.swing.GroupLayout(jPanelDisposeCode);
        jPanelDisposeCode.setLayout(jPanelDisposeCodeLayout);
        jPanelDisposeCodeLayout.setHorizontalGroup(
            jPanelDisposeCodeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane8, javax.swing.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE)
        );
        jPanelDisposeCodeLayout.setVerticalGroup(
            jPanelDisposeCodeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane8, javax.swing.GroupLayout.DEFAULT_SIZE, 433, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("Dispose Code", jPanelDisposeCode);

        jTextAreaMidiCode.setColumns(20);
        jTextAreaMidiCode.setLineWrap(true);
        jTextAreaMidiCode.setRows(5);
        jTextAreaMidiCode.setWrapStyleWord(true);
        jScrollPane10.setViewportView(jTextAreaMidiCode);

        javax.swing.GroupLayout jPanelMidiCodeLayout = new javax.swing.GroupLayout(jPanelMidiCode);
        jPanelMidiCode.setLayout(jPanelMidiCodeLayout);
        jPanelMidiCodeLayout.setHorizontalGroup(
            jPanelMidiCodeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane10, javax.swing.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE)
        );
        jPanelMidiCodeLayout.setVerticalGroup(
            jPanelMidiCodeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane10, javax.swing.GroupLayout.DEFAULT_SIZE, 433, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("MIDI Code", jPanelMidiCode);

        jPanel1.add(jTabbedPane1);

        jLabel2.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel1.add(jLabel2);

        jSplitPane1.setLeftComponent(jPanel1);

        getContentPane().add(jSplitPane1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JInternalFrame jInternalFrame1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JList jListAttributes;
    private javax.swing.JList jListInlets;
    private javax.swing.JList jListOutlets;
    private javax.swing.JList jListParameters;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanelAttributes;
    private javax.swing.JPanel jPanelDisposeCode;
    private javax.swing.JPanel jPanelInitCode;
    private javax.swing.JPanel jPanelInlets;
    private javax.swing.JPanel jPanelKRateCode;
    private javax.swing.JPanel jPanelLocalData;
    private javax.swing.JPanel jPanelMidiCode;
    private javax.swing.JPanel jPanelOutlets;
    private javax.swing.JPanel jPanelParameters;
    private javax.swing.JPanel jPanelSRateCode;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane10;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextAreaDisposeCode;
    private javax.swing.JTextArea jTextAreaInitCode;
    private javax.swing.JTextArea jTextAreaKRateCode;
    private javax.swing.JTextArea jTextAreaLocalData;
    private javax.swing.JTextArea jTextAreaMidiCode;
    private javax.swing.JTextArea jTextAreaSRateCode;
    // End of variables declaration//GEN-END:variables
}
