/**
 * Copyright (C) 2013, 2014 Johannes Taelman
 *
 * This file is part of Axoloti.
 *
 * Axoloti is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * Axoloti is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Axoloti. If not, see <http://www.gnu.org/licenses/>.
 */
package displays;

import axoloti.datatypes.Value;
import axoloti.datatypes.ValueFrac32;
import components.displays.VBarComponentDB;

/**
 *
 * @author Johannes Taelman
 */
public class DisplayInstanceFrac32VBarDB extends DisplayInstance1 {

    ValueFrac32 value = new ValueFrac32();

    @Override
    public Value getValueRef() {
        return value;
    }

    private VBarComponentDB vbar;

    public DisplayInstanceFrac32VBarDB() {
    }

    @Override
    public void PostConstructor() {
        super.PostConstructor();
        vbar = new VBarComponentDB(-200, -60, 10);
        vbar.setValue(0);
        add(vbar);
    }

    @Override
    public void updateV() {
        vbar.setValue(value.getDouble());
    }
}
